create sequence metadata_seq minvalue 0;

create table metadata (
  id   number(19)   not null,
  name varchar(256) not null,
  constraint metadata_id_pkey primary key (id)
);

create table metadata_entries (
  meta_id       number(19) not null,
  idx           number(19) default -1 not null,
  string_value  varchar(1000),
  numeric_value number(20, 10),
  boolean_value number(1),
  constraint metadata_entries_uniq unique (meta_id, idx)
);

create table run_meta (
  meta_id  number(19),
  scen_id  number(19),
  model_id number(19),
  version  number(19),
  constraint metadata_meta_id_fkey foreign key (meta_id) references metadata (id),
  constraint metadata_scen_id_fkey foreign key (scen_id) references scenario (id),
  constraint metadata_model_id_fkey foreign key (model_id) references model (id)
);